This mod **greatly improves multiplayer performance.** If you find this mod works as advertised, please endorse it!

**For most people, the default settings should be fine.**

**Changing settings using the Configuration Manager (F1)**

1. If others experience lag/desync for things *around* you, increase your queue size.
1. If your *character* is lagging for others, decrease your update rate and/or queue size.
1. If your internet is slower, it might help to reduce the send rates until they're below [your upload speed](https://speedof.me/).

**Things to keep in mind**

* Compression only works between computers with Better Networking.
* Incompatible with other networking mods, including VNO and NetworkFix.
* Compression increases your CPU usage. This can become the new bottleneck in some cases. With this mod, Valheim can max out two cores, so with 4 cores, 50% CPU usage by Valheim is maxing it out.
* Dedicated servers will not apply changes until restarted.

**Finished features**

* optionally compress network data (improves performance for everyone; requires others to have mod)
* sending queued packages all at once instead of one at a time (improves performance for everyone, especially if you have high ping; requires others to have mod)
* option to reduce network update speed (for computers with slow/inconsistent upload speeds)
* change min/max send rates (higher can be better with good internet)
* change network queue size (Valheim better prioritizes data when queue size is lower, but sends less data overall)
* increased networking buffer size (might help)

**Planned features**

* optionally require players to have certain mods to join server
* optionally notify players if they have an older version of a mod than others
* allow admins to change dedicated server settings within their client without having to restart server
* option to allow players to choose who the server is
* better data prioritization
* improved networking regarding terrain
* make everything automatic (fewer options)

**Better Networking links**

* Please [provide feedback here in the discussions!](https://www.nexusmods.com/valheim/mods/1570?tab=posts)
* [Report a Better Networking bug!](https://www.nexusmods.com/valheim/mods/1570?tab=bugs)
* [Better Networking on Nexus Mods](https://www.nexusmods.com/valheim/mods/1570)
* [Better Networking on ThunderStore](https://valheim.thunderstore.io/package/CW_Jesse/BetterNetworking_Valheim/)

**Educational links**

* [Technical explanation of Valheim's networking](https://redd.it/mga1iw) by u/SleepMyLittleOnes
* [Discussion on desync/lag in Valheim](https://jamesachambers.com/revisiting-fixing-valheim-lag-modifying-send-receive-limits/#comment-11709) on the blog of James A. Chambers

**Other networking mods**

* [NetworkFix](https://github.com/Dalayeth/NetworkFix) mod by Dalayeth (incompatible with Better Networking)
* [Valheim Network Optimizer](https://www.nexusmods.com/valheim/mods/537) mod by TripleSteel (incompatible with Better Networking)

**If you've benefited from this mod and want to see more features implemented, please endorse it! Or if you're feeling particularly generous, donate here or [on Patreon](https://www.patreon.com/CW_Jesse)!**